#!/usr/bin/python3
import sys, os, dbus


class Function:

    def __init__(self):
        pass

    def chose_function(self, id, arg):
        function = getattr(self, id)
        return function(arg)

    def riskcommand(self, arg):
        if arg == "null":
            return "正常运行"
        else:
            return "阻断运行"

    def Nonauthoritative(self, arg):
        begin = arg.rfind('/') + 1
        end = arg.rfind('.')
        if end == -1:
            name = arg[begin:]
        else:
            name = arg[begin:end]
        path = "/usr/share/applications/" + name + ".desktop"
        if os.path.exists(path):
            with open(path, "r") as e:
                for line in e.readlines():
                    if line.startswith("GenericName[zh_CN]="):
                        name = line[19:]
                        return name
                    elif line.startswith("Name[zh_CN]="):
                        name = line[12:]
                        return name
                    elif line.startswith("Name="):
                        name = line[5:]
        return name

    def essential_process(self, arg):
        try:
            SystemBus = dbus.SystemBus()
            proxy = SystemBus.get_object(bus_name="com.kylin.processMonitor", object_path="/com/kylin/processMonitor")
            call_bus_method = dbus.Interface(proxy, dbus_interface="com.kylin.processMonitor.startend")
            way = getattr(call_bus_method, "getCommandbyPid")
            res = way(arg)
            return res
        except Exception:
            return ""


if __name__ == "__main__":
    f = Function()
    id = sys.argv[1]
    arg = sys.argv[2]
    print(f.chose_function(id, arg))


